export class Err {
    constructor(val) {
        this.val = val;
        this.ok = false;
        this.err = true;
    }
    /**
     * If the result has a value returns that value.  Otherwise returns the passed in value.
     * @param val the value to replace the error with
     */
    else(val) {
        return val;
    }
    expect(msg) {
        let value = this.val.toString();
        if (value === '[object Object]') {
            try {
                value = JSON.stringify(value);
            }
            catch (e) {
            }
        }
        throw new Error(`${msg} - Error: ${value}`);
    }
    unwrap() {
        let value = this.val.toString();
        if (value === '[object Object]') {
            try {
                value = JSON.stringify(value);
            }
            catch (e) {
            }
        }
        throw new Error(`Tried to unwrap Error: ${value}`);
    }
    map(mapper) {
        return this;
    }
    mapErr(mapper) {
        return new Err(mapper(this.val));
    }
}
Err.EMPTY = new Err(undefined);
export class Ok {
    constructor(val) {
        this.val = val;
        this.ok = true;
        this.err = false;
    }
    /**
     * If the result has a value returns that value.  Otherwise returns the passed in value.
     * @param val the value to replace the error with
     */
    else(val) {
        return this.val;
    }
    expect(msg) {
        return this.val;
    }
    unwrap() {
        return this.val;
    }
    map(mapper) {
        return new Ok(mapper(this.val));
    }
    mapErr(mapper) {
        return this;
    }
}
Ok.EMPTY = new Ok(undefined);
export function Results(...results) {
    const okResult = [];
    for (let result of results) {
        if (result.ok) {
            okResult.push(result.val);
        }
        else {
            return new Err(result.val);
        }
    }
    return new Ok(okResult);
}
//# sourceMappingURL=index.js.map