import { ObservableInput, OperatorFunction } from 'rxjs';
import { Result, ResultErrType, ResultOkType } from './index';
export declare function resultMap<R extends Result<any, any>, T>(mapper: (val: ResultOkType<R>) => T): OperatorFunction<R, Result<T, ResultErrType<R>>>;
export declare function resultMapErr<R extends Result<any, any>, E>(mapper: (val: ResultErrType<R>) => E): OperatorFunction<R, Result<ResultOkType<R>, E>>;
export declare function resultMapTo<R extends Result<any, any>, T>(value: T): OperatorFunction<R, Result<T, ResultErrType<R>>>;
export declare function resultMapErrTo<R extends Result<any, any>, T>(value: T): OperatorFunction<R, Result<ResultOkType<R>, T>>;
export declare function elseMap<R extends Result<any, any>, T>(mapper: (val: ResultErrType<R>) => T): OperatorFunction<R, ResultOkType<R> | T>;
export declare function elseMapTo<R extends Result<any, any>, T>(value: T): OperatorFunction<R, ResultOkType<R> | T>;
export declare function resultSwitchMap<R extends Result<any, any>, T extends Result<any, any>>(mapper: (val: ResultOkType<R>) => ObservableInput<T>): OperatorFunction<R, Result<ResultOkType<T>, ResultErrType<R> | ResultErrType<T>>>;
export declare function resultSwitchMap<R extends Result<any, any>, T>(mapper: (val: ResultOkType<R>) => ObservableInput<T>): OperatorFunction<R, Result<T, ResultErrType<R>>>;
export declare function resultMergeMap<R extends Result<any, any>, T extends Result<any, any>>(mapper: (val: ResultOkType<R>) => ObservableInput<T>): OperatorFunction<R, Result<ResultOkType<T>, ResultErrType<R> | ResultErrType<T>>>;
export declare function resultMergeMap<R extends Result<any, any>, T>(mapper: (val: ResultOkType<R>) => ObservableInput<T>): OperatorFunction<R, Result<T, ResultErrType<R>>>;
export declare function filterResultOk<R extends Result<any, any>>(): OperatorFunction<R, ResultOkType<R>>;
export declare function filterResultErr<R extends Result<any, any>>(): OperatorFunction<R, ResultErrType<R>>;
